<?php if (!defined('PmWiki')) exit();
/** \abcsong.php
 * \A recipe to allow ABC notation to produce playable music and words on a web page.
 *
 * A demonstration site is at http://s593332318.websitehome.co.uk/abcmedia/pmwiki/pmwiki.php?n=SongBook.SongBook
 * with full instructions on the recipe page at ABCHelp.ABCHelp, or on the demonstartion site at 
 * http://s593332318.websitehome.co.uk/abcmedia/pmwiki/pmwiki.php?n=Main.SongbookHelp
 *
 * Change notes
 * 2020-01-01 Original issue
 *
 * 2020-02-18 Update 1
 * Only raw abc code needs to be entered on page
 * Can select audio controls top or bottom of music
 * Improved printing
 *
 */
// This recipe's name and version
$RecipeInfo['abcsong']['Version'] = '2020-02-18';

$ActionSkin['print'] = 'abc-print';

$HTMLHeaderFmt['show'] =
					'
			<script>
			function ShowHide() {
			  var x = document.getElementById("abc");
			  if (x.style.display === "none") {
				x.style.display = "block";
			  } else {
				x.style.display = "none";
			  }
			}
		</script>';

## set default song group
#Others may be added in config.php
$SongGroup[] = "Songbook";

## Get the group and page name
$pagename = ResolvePageName($pagename);
$page = PageVar($pagename, '$FullName');
$group = PageVar($pagename, '$Group');
$name = PageVar($pagename, '$Name');

## Set to 1 to ignore definite and indefinite article in page lists and sorts
# Add to config.php - 
#         $ignoreArticle = 1;
if($IgnoreArticle==1) {
	$FmtPV['$FullTitle'] = $FmtPV['$Title'];
	$FmtPV['$Title'] = "preg_replace('/^(A|The|Les|Ye) /','',".$FmtPV['$Titlespaced'].")";
	}
	
## set template page
$EditTemplatesFmt = '{$Group}.Template';
	
if (in_array($group, $SongGroup)){
	if ($name <> $group) {
		if($action!='edit' and $action!='diff' and $action!='login') {
			
			$FmtPV['$PlainText'] = 'FmtPlainText($pn)';
			
			function FmtPlainText($pn) {
				$page = RetrieveAuthPage($pn, 'read', false, READPAGE_CURRENT);
				if (! @$page['text']) return '';
				return Keep(PHSC($page['text'], ENT_QUOTES));
				}
	
			if($action=='print') {
				# hide midibar, buttons, download link
				Markup("abc", "inline", "/abc(.*?)abc/", "
				</div>
				<textarea id='abc' cols='80' rows='15' style='display:none;'>$1</textarea>
				<div id='warnings'></div>
				<div id='canvas'></div>;");
				} else {
				if ($Top == 0) {
					# place midi bar at bottom
					Markup("abc", "inline", "/abc(.*?)abc/", "
					</div>
					<div>
					<button onclick='ShowHide()'>Show/Hide ABC</button>
					</div>
					<textarea id='abc' cols='80' rows='15' style='display:none;'>$1</textarea>
					<div id='warnings'></div>
					<div id='download'></div>
					<div id='canvas'></div>
					<div id='midi'></div>;");
					} else {
					# midi bar at top
					Markup("abc", "inline", "/abc(.*?)abc/", "
					</div>
					<div>
					<button onclick='ShowHide()'>Show/Hide ABC</button>
					</div>
					<textarea id='abc' cols='80' rows='15' style='display:none;'>$1</textarea>
					<div id='warnings'></div>
					<div id='midi'></div>
					<div id='download'></div>
					<div id='canvas'></div>;");

					}
				}
			
							
				$PageTextStartFmt = "<div style='display: none'>";
			
				if ($MidiDownload == 0) {
					# No download link
					$HTMLHeaderFmt['abc'] =
					'
					<!-- ABC -->
					<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
					<link rel="stylesheet" type="text/css" href="$PubDirUrl/abcjs/abcjs-midi.css">
					<script src="$PubDirUrl/abcjs/abcjs_midi_6.0.0-3-min.js" type="text/javascript"></script>
					<script type="text/javascript">
						window.onload = function () {
							new ABCJS.Editor("abc", {
								canvas_id: "canvas",
								generate_midi: true,
								midi_id: "midi",
								warnings_id: "warnings",
								abcjsParams: {
									generateInline: true,
									generateDownload: true
								}
							});


						}

					</script>';
				} else {
					# Download link available
					$HTMLHeaderFmt['abc'] =
					'
					<!-- ABC -->
					<link rel="stylesheet" type="text/css" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
					<link rel="stylesheet" type="text/css" href="$PubDirUrl/abcjs/abcjs-midi.css">
					<script src="$PubDirUrl/abcjs/abcjs_midi_6.0.0-3-min.js" type="text/javascript"></script>
					<script type="text/javascript">
						window.onload = function () {
							new ABCJS.Editor("abc", {
								canvas_id: "canvas",
								generate_midi: true,
								midi_id: "midi",
								warnings_id: "warnings",
								midi_download_id: "download",
								abcjsParams: {
									generateInline: true,
									generateDownload: true
								}
							});


						}

					</script>';
				}
			}
		}

	}


